Index: cpukit/libdl/rtl-mdreloc-powerpc.c
===================================================================
--- cpukit/libdl/rtl-mdreloc-powerpc.c	(revision d51538bdbe5ea9e71a7205e39fcef387fbdb4b39)
+++ cpukit/libdl/rtl-mdreloc-powerpc.c	(revision d2e31f70c12f6363cef79ffad781df6ec0acdfb5)
@@ -16,4 +16,6 @@
 #include "rtl-error.h"
 #include "rtl-trace.h"
+#include "rtl-unwind.h"
+#include "rtl-unwind-dw2.h"
 
 #define ha(x) ((((u_int32_t)(x) & 0x8000) ? \
@@ -21,4 +23,10 @@
 #define l(x) ((u_int32_t)(x) & 0xffff)
 
+uint32_t
+rtems_rtl_elf_section_flags (const rtems_rtl_obj_t* obj,
+                             const Elf_Shdr*        shdr)
+{
+  return 0;
+}
 
 bool
@@ -157,4 +165,20 @@
         printf ("rtl: REL32 %p @ %p in %s\n",
                 (void *)*where, where, rtems_rtl_obj_oname (obj));
+      break;
+
+    case R_TYPE(SDAREL16):
+      /*
+       * A sign-extended 16 bit value relative to _SDA_BASE_, for use with
+       * small data items.
+       */
+      mask = 0xffff;
+      tmp = *((Elf32_Half*) where);
+      tmp &= ~mask;
+      tmp |= (symvalue + rela->r_addend - (Elf_Addr)where) & mask;
+      *((Elf32_Half*) where) = tmp;
+      if (rtems_rtl_trace (RTEMS_RTL_TRACE_RELOC))
+        printf ("rtl: SDAREL16 %p @ %p in %s\n",
+                (void *) (uintptr_t) *((Elf32_Half*) where),
+                where, rtems_rtl_obj_oname (obj));
       break;
 
@@ -184,2 +208,22 @@
   return false;
 }
+
+bool
+rtems_rtl_elf_unwind_parse (const rtems_rtl_obj_t* obj,
+                            const char*            name,
+                            uint32_t               flags)
+{
+  return rtems_rtl_elf_unwind_dw2_parse (obj, name, flags);
+}
+
+bool
+rtems_rtl_elf_unwind_register (rtems_rtl_obj_t* obj)
+{
+  return rtems_rtl_elf_unwind_dw2_register (obj);
+}
+
+bool
+rtems_rtl_elf_unwind_deregister (rtems_rtl_obj_t* obj)
+{
+  return rtems_rtl_elf_unwind_dw2_deregister (obj);
+}
Index: cpukit/libdl/rtl-mdreloc-sparc.c
===================================================================
--- cpukit/libdl/rtl-mdreloc-sparc.c	(revision d51538bdbe5ea9e71a7205e39fcef387fbdb4b39)
+++ cpukit/libdl/rtl-mdreloc-sparc.c	(revision d2e31f70c12f6363cef79ffad781df6ec0acdfb5)
@@ -42,4 +42,6 @@
 #include "rtl-error.h"
 #include "rtl-trace.h"
+#include "rtl-unwind.h"
+#include "rtl-unwind-dw2.h"
 
 /*
@@ -129,4 +131,11 @@
 #define RELOC_VALUE_BITMASK(t)  (reloc_target_bitmask[t])
 
+uint32_t
+rtems_rtl_elf_section_flags (const rtems_rtl_obj_t* obj,
+                             const Elf_Shdr*        shdr)
+{
+  return 0;
+}
+
 bool
 rtems_rtl_elf_rel_resolve_sym (Elf_Word type)
@@ -145,4 +154,5 @@
   Elf_Addr *where;
   Elf_Word type, value, mask;
+  Elf_Addr tmp = 0;
 
   where = (Elf_Addr *) (sect->base + rela->r_offset);
@@ -220,11 +230,12 @@
 
   if (RELOC_UNALIGNED(type)) {
-    /* Handle unaligned relocations. */
-    Elf_Addr tmp = 0;
-    char *ptr = (char *)where;
+    /*
+     * Handle unaligned relocations.
+     */
+    char *ptr = (char*) where;
     int i, size = RELOC_TARGET_SIZE (type) / 8;
 
     /* Read it in one byte at a time. */
-    for (i=0; i<size; i++)
+    for (i = size - 1; i >= 0; i--)
       tmp = (tmp << 8) | ptr[i];
 
@@ -233,16 +244,16 @@
 
     /* Write it back out. */
-    for (i=0; i<size; i++)
-      ptr[i] = ((tmp >> (8*i)) & 0xff);
-
+    for (i = size - 1; i >= 0; i--, tmp >>= 8)
+      ptr[i] = tmp & 0xff;
   } else {
     *where &= ~mask;
     *where |= value;
+    tmp = *where;
   }
 
   if (rtems_rtl_trace (RTEMS_RTL_TRACE_RELOC))
     printf ("rtl: %s %p @ %p in %s\n",
-            reloc_names[type], (void *)*where, where, rtems_rtl_obj_oname (obj));
-
+            reloc_names[ELF_R_TYPE(rela->r_info)],
+            (void *)tmp, where, rtems_rtl_obj_oname (obj));
 
   return true;
@@ -260,2 +271,22 @@
   return false;
 }
+
+bool
+rtems_rtl_elf_unwind_parse (const rtems_rtl_obj_t* obj,
+                            const char*            name,
+                            uint32_t               flags)
+{
+  return rtems_rtl_elf_unwind_dw2_parse (obj, name, flags);
+}
+
+bool
+rtems_rtl_elf_unwind_register (rtems_rtl_obj_t* obj)
+{
+  return rtems_rtl_elf_unwind_dw2_register (obj);
+}
+
+bool
+rtems_rtl_elf_unwind_deregister (rtems_rtl_obj_t* obj)
+{
+  return rtems_rtl_elf_unwind_dw2_deregister (obj);
+}
Index: cpukit/libdl/rtl-mdreloc-v850.c
===================================================================
--- cpukit/libdl/rtl-mdreloc-v850.c	(revision d51538bdbe5ea9e71a7205e39fcef387fbdb4b39)
+++ cpukit/libdl/rtl-mdreloc-v850.c	(revision d2e31f70c12f6363cef79ffad781df6ec0acdfb5)
@@ -11,4 +11,13 @@
 #include "rtl-error.h"
 #include "rtl-trace.h"
+#include "rtl-unwind.h"
+#include "rtl-unwind-dw2.h"
+
+uint32_t
+rtems_rtl_elf_section_flags (const rtems_rtl_obj_t* obj,
+                             const Elf_Shdr*        shdr)
+{
+  return 0;
+}
 
 bool
@@ -96,2 +105,22 @@
   return false;
 }
+
+bool
+rtems_rtl_elf_unwind_parse (const rtems_rtl_obj_t* obj,
+                            const char*            name,
+                            uint32_t               flags)
+{
+  return rtems_rtl_elf_unwind_dw2_parse (obj, name, flags);
+}
+
+bool
+rtems_rtl_elf_unwind_register (rtems_rtl_obj_t* obj)
+{
+  return rtems_rtl_elf_unwind_dw2_register (obj);
+}
+
+bool
+rtems_rtl_elf_unwind_deregister (rtems_rtl_obj_t* obj)
+{
+  return rtems_rtl_elf_unwind_dw2_deregister (obj);
+}
Index: cpukit/libdl/rtl-obj.c
===================================================================
--- cpukit/libdl/rtl-obj.c	(revision d51538bdbe5ea9e71a7205e39fcef387fbdb4b39)
+++ cpukit/libdl/rtl-obj.c	(revision d2e31f70c12f6363cef79ffad781df6ec0acdfb5)
@@ -50,12 +50,19 @@
  * The table of supported loader formats.
  */
-static rtems_rtl_loader_table_t loaders[RTEMS_RTL_ELF_LOADER_COUNT +
-                                        RTEMS_RTL_RAP_LOADER_COUNT] =
+#define RTEMS_RTL_LOADERS (RTEMS_RTL_ELF_LOADER_COUNT + RTEMS_RTL_RAP_LOADER_COUNT)
+static const rtems_rtl_loader_table_t loaders[RTEMS_RTL_LOADERS] =
 {
 #if RTEMS_RTL_RAP_LOADER
-  { rtems_rtl_rap_file_check, rtems_rtl_rap_file_load, rtems_rtl_rap_file_sig },
+  { .check     = rtems_rtl_rap_file_check,
+    .load      = rtems_rtl_rap_file_load,
+    .unload    = rtems_rtl_rap_file_unload,
+    .unload    = rtems_rtl_rap_file_unload,
+    .signature = rtems_rtl_rap_file_sig },
 #endif
 #if RTEMS_RTL_ELF_LOADER
-  { rtems_rtl_elf_file_check, rtems_rtl_elf_file_load, rtems_rtl_elf_file_sig },
+  { .check     = rtems_rtl_elf_file_check,
+    .load      = rtems_rtl_elf_file_load,
+    .unload    = rtems_rtl_elf_file_unload,
+    .signature = rtems_rtl_elf_file_sig },
 #endif
 };
@@ -73,4 +80,8 @@
      */
     rtems_chain_initialize_empty (&obj->sections);
+    /*
+     * No valid format.
+     */
+    obj->format = -1;
   }
   return obj;
@@ -98,5 +109,5 @@
   if (!rtems_chain_is_node_off_chain (&obj->link))
     rtems_chain_extract (&obj->link);
-  rtems_rtl_alloc_module_del (&obj->text_base, &obj->const_base,
+  rtems_rtl_alloc_module_del (&obj->text_base, &obj->const_base, &obj->eh_base,
                               &obj->data_base, &obj->bss_base);
   rtems_rtl_symbol_obj_erase (obj);
@@ -104,6 +115,6 @@
   if (obj->sec_num)
     free (obj->sec_num);
-  if (obj->detail)
-    rtems_rtl_alloc_del (RTEMS_RTL_ALLOC_OBJECT, (void*)obj->detail);
+  if (obj->linkmap)
+    rtems_rtl_alloc_del (RTEMS_RTL_ALLOC_OBJECT, (void*) obj->linkmap);
   rtems_rtl_alloc_del (RTEMS_RTL_ALLOC_OBJECT, obj);
   return true;
@@ -239,5 +250,5 @@
 rtems_rtl_sect_align (size_t offset, uint32_t alignment)
 {
-  if ((alignment > 1) && ((offset & ~alignment) != 0))
+  if ((alignment > 1) && ((offset & (alignment - 1)) != 0))
     offset = (offset + alignment) & ~(alignment - 1);
   return offset;
@@ -265,10 +276,10 @@
 
 static size_t
-rtems_rtl_obj_section_size (rtems_rtl_obj_t* obj, uint32_t mask)
+rtems_rtl_obj_section_size (const rtems_rtl_obj_t* obj, uint32_t mask)
 {
   rtems_rtl_obj_sect_summer_t summer;
   summer.mask = mask;
   summer.size = 0;
-  rtems_rtl_chain_iterate (&obj->sections,
+  rtems_rtl_chain_iterate ((rtems_chain_control*) &obj->sections,
                            rtems_rtl_obj_sect_summer,
                            &summer);
@@ -303,10 +314,10 @@
 
 static size_t
-rtems_rtl_obj_section_alignment (rtems_rtl_obj_t* obj, uint32_t mask)
+rtems_rtl_obj_section_alignment (const rtems_rtl_obj_t* obj, uint32_t mask)
 {
   rtems_rtl_obj_sect_aligner_t aligner;
   aligner.mask = mask;
   aligner.alignment = 0;
-  rtems_rtl_chain_iterate (&obj->sections,
+  rtems_rtl_chain_iterate ((rtems_chain_control*) &obj->sections,
                            rtems_rtl_obj_sect_aligner,
                            &aligner);
@@ -402,24 +413,28 @@
                            uint32_t         flags)
 {
-  rtems_rtl_obj_sect_t* sect = rtems_rtl_alloc_new (RTEMS_RTL_ALLOC_OBJECT,
-                                                    sizeof (rtems_rtl_obj_sect_t), true);
-  if (!sect)
-  {
-    rtems_rtl_set_error (ENOMEM, "adding allocated section");
-    return false;
-  }
-  sect->section = section;
-  sect->name = rtems_rtl_strdup (name);
-  sect->size = size;
-  sect->offset = offset;
-  sect->alignment = alignment;
-  sect->link = link;
-  sect->info = info;
-  sect->flags = flags;
-  sect->base = NULL;
-  rtems_chain_append (&obj->sections, &sect->node);
-
-  if (rtems_rtl_trace (RTEMS_RTL_TRACE_SECTION))
-    printf ("rtl: sect: %-2d: %s\n", section, name);
+  if (size > 0)
+  {
+    rtems_rtl_obj_sect_t* sect = rtems_rtl_alloc_new (RTEMS_RTL_ALLOC_OBJECT,
+                                                      sizeof (rtems_rtl_obj_sect_t),
+                                                      true);
+    if (!sect)
+    {
+      rtems_rtl_set_error (ENOMEM, "adding allocated section");
+      return false;
+    }
+    sect->section = section;
+    sect->name = rtems_rtl_strdup (name);
+    sect->size = size;
+    sect->offset = offset;
+    sect->alignment = alignment;
+    sect->link = link;
+    sect->info = info;
+    sect->flags = flags;
+    sect->base = NULL;
+    rtems_chain_append (&obj->sections, &sect->node);
+
+    if (rtems_rtl_trace (RTEMS_RTL_TRACE_SECTION))
+      printf ("rtl: sect: %-2d: %s (%zu)\n", section, name, size);
+  }
 
   return true;
@@ -465,10 +480,11 @@
 
 rtems_rtl_obj_sect_t*
-rtems_rtl_obj_find_section (rtems_rtl_obj_t* obj, const char* name)
+rtems_rtl_obj_find_section (const rtems_rtl_obj_t* obj,
+                            const char*            name)
 {
   rtems_rtl_obj_sect_finder_t match;
   match.sect = NULL;
   match.name = name;
-  rtems_rtl_chain_iterate (&obj->sections,
+  rtems_rtl_chain_iterate ((rtems_chain_control*) &obj->sections,
                            rtems_rtl_obj_sect_match_name,
                            &match);
@@ -490,10 +506,11 @@
 
 rtems_rtl_obj_sect_t*
-rtems_rtl_obj_find_section_by_index (rtems_rtl_obj_t* obj, int index)
+rtems_rtl_obj_find_section_by_index (const rtems_rtl_obj_t* obj,
+                                     int                    index)
 {
   rtems_rtl_obj_sect_finder_t match;
   match.sect = NULL;
   match.index = index;
-  rtems_rtl_chain_iterate (&obj->sections,
+  rtems_rtl_chain_iterate ((rtems_chain_control*) &obj->sections,
                            rtems_rtl_obj_sect_match_index,
                            &match);
@@ -502,5 +519,5 @@
 
 size_t
-rtems_rtl_obj_text_size (rtems_rtl_obj_t* obj)
+rtems_rtl_obj_text_size (const rtems_rtl_obj_t* obj)
 {
   return rtems_rtl_obj_section_size (obj, RTEMS_RTL_OBJ_SECT_TEXT);
@@ -508,5 +525,5 @@
 
 uint32_t
-rtems_rtl_obj_text_alignment (rtems_rtl_obj_t* obj)
+rtems_rtl_obj_text_alignment (const rtems_rtl_obj_t* obj)
 {
   return rtems_rtl_obj_section_alignment (obj, RTEMS_RTL_OBJ_SECT_TEXT);
@@ -514,5 +531,5 @@
 
 size_t
-rtems_rtl_obj_const_size (rtems_rtl_obj_t* obj)
+rtems_rtl_obj_const_size (const rtems_rtl_obj_t* obj)
 {
   return rtems_rtl_obj_section_size (obj, RTEMS_RTL_OBJ_SECT_CONST);
@@ -520,5 +537,17 @@
 
 uint32_t
-rtems_rtl_obj_const_alignment (rtems_rtl_obj_t* obj)
+rtems_rtl_obj_eh_alignment (const rtems_rtl_obj_t* obj)
+{
+  return rtems_rtl_obj_section_alignment (obj, RTEMS_RTL_OBJ_SECT_EH);
+}
+
+size_t
+rtems_rtl_obj_eh_size (const rtems_rtl_obj_t* obj)
+{
+  return rtems_rtl_obj_section_size (obj, RTEMS_RTL_OBJ_SECT_EH);
+}
+
+uint32_t
+rtems_rtl_obj_const_alignment (const rtems_rtl_obj_t* obj)
 {
   return rtems_rtl_obj_section_alignment (obj, RTEMS_RTL_OBJ_SECT_CONST);
@@ -526,5 +555,5 @@
 
 size_t
-rtems_rtl_obj_data_size (rtems_rtl_obj_t* obj)
+rtems_rtl_obj_data_size (const rtems_rtl_obj_t* obj)
 {
   return rtems_rtl_obj_section_size (obj, RTEMS_RTL_OBJ_SECT_DATA);
@@ -532,5 +561,5 @@
 
 uint32_t
-rtems_rtl_obj_data_alignment (rtems_rtl_obj_t* obj)
+rtems_rtl_obj_data_alignment (const rtems_rtl_obj_t* obj)
 {
   return rtems_rtl_obj_section_alignment (obj, RTEMS_RTL_OBJ_SECT_DATA);
@@ -538,5 +567,5 @@
 
 size_t
-rtems_rtl_obj_bss_size (rtems_rtl_obj_t* obj)
+rtems_rtl_obj_bss_size (const rtems_rtl_obj_t* obj)
 {
   return rtems_rtl_obj_section_size (obj, RTEMS_RTL_OBJ_SECT_BSS);
@@ -544,5 +573,5 @@
 
 uint32_t
-rtems_rtl_obj_bss_alignment (rtems_rtl_obj_t* obj)
+rtems_rtl_obj_bss_alignment (const rtems_rtl_obj_t* obj)
 {
   return rtems_rtl_obj_section_alignment (obj, RTEMS_RTL_OBJ_SECT_BSS);
@@ -573,19 +602,23 @@
 rtems_rtl_obj_sect_sync_handler (rtems_chain_node* node, void* data)
 {
-  rtems_rtl_obj_sect_t*   sect = (rtems_rtl_obj_sect_t*) node;
+  rtems_rtl_obj_sect_t*          sect = (rtems_rtl_obj_sect_t*) node;
   rtems_rtl_obj_sect_sync_ctx_t* sync_ctx = data;
-  uintptr_t old_end;
-  uintptr_t new_start;
-
-  if ( !(sect->flags & sync_ctx->mask) || !sect->size)
+  uintptr_t                      old_end;
+  uintptr_t                      new_start;
+
+  if ((sect->flags & sync_ctx->mask) == 0 || sect->size == 0)
     return true;
 
-  if (sync_ctx->end_va == sync_ctx->start_va) {
+  if (sync_ctx->end_va == sync_ctx->start_va)
+  {
     sync_ctx->start_va = sect->base;
-  } else {
-    old_end = (uintptr_t)sync_ctx->end_va & ~(sync_ctx->cache_line_size - 1);
-    new_start = (uintptr_t)sect->base & ~(sync_ctx->cache_line_size - 1);
-    if ( (sect->base <  sync_ctx->start_va) ||
-         (new_start - old_end > sync_ctx->cache_line_size) ) {
+  }
+  else
+  {
+    old_end = (uintptr_t) sync_ctx->end_va & ~(sync_ctx->cache_line_size - 1);
+    new_start = (uintptr_t) sect->base & ~(sync_ctx->cache_line_size - 1);
+    if ((sect->base <  sync_ctx->start_va) ||
+        (new_start - old_end > sync_ctx->cache_line_size))
+    {
       rtems_cache_instruction_sync_after_code_change(sync_ctx->start_va,
                              sync_ctx->end_va - sync_ctx->start_va + 1);
@@ -600,5 +633,5 @@
 
 void
-rtems_rtl_obj_synchronize_cache (rtems_rtl_obj_t*    obj)
+rtems_rtl_obj_synchronize_cache (rtems_rtl_obj_t* obj)
 {
   rtems_rtl_obj_sect_sync_ctx_t sync_ctx;
@@ -611,5 +644,5 @@
   sync_ctx.mask = RTEMS_RTL_OBJ_SECT_TEXT | RTEMS_RTL_OBJ_SECT_CONST |
                   RTEMS_RTL_OBJ_SECT_DATA | RTEMS_RTL_OBJ_SECT_BSS |
-                  RTEMS_RTL_OBJ_SECT_EXEC;
+                  RTEMS_RTL_OBJ_SECT_EH   | RTEMS_RTL_OBJ_SECT_EXEC;
 
   sync_ctx.start_va = 0;
@@ -633,4 +666,85 @@
   uint32_t mask = RTEMS_RTL_OBJ_SECT_SYM;
   return rtems_rtl_obj_section_handler (mask, obj, fd, handler, data);
+}
+
+static int
+rtems_rtl_obj_sections_linked_to_order (rtems_rtl_obj_t* obj,
+                                        int              section,
+                                        uint32_t         visited_mask)
+{
+  rtems_chain_control* sections = &obj->sections;
+  rtems_chain_node*    node = rtems_chain_first (sections);
+  /*
+   * Find the section being linked-to. If the linked-to link field is 0 we have
+   * the end and the section's order is the position we are after.
+   */
+  while (!rtems_chain_is_tail (sections, node))
+  {
+    rtems_rtl_obj_sect_t* sect = (rtems_rtl_obj_sect_t*) node;
+    if (sect->section == section)
+    {
+      const uint32_t mask = sect->flags & RTEMS_RTL_OBJ_SECT_TYPES;
+      int            order = 0;
+      if (sect->link != 0)
+      {
+        /*
+         * Have we already visited this type of section? Avoid nesting for
+         * ever.
+         */
+        if ((sect->flags & visited_mask) != 0)
+        {
+          rtems_rtl_set_error (errno, "section link loop");
+          return -1;
+        }
+        return rtems_rtl_obj_sections_linked_to_order (obj,
+                                                       sect->link,
+                                                       visited_mask | mask);
+      }
+      node = rtems_chain_first (sections);
+      while (!rtems_chain_is_tail (sections, node))
+      {
+        sect = (rtems_rtl_obj_sect_t*) node;
+        if ((sect->flags & mask) == mask)
+        {
+          if (sect->section == section)
+            return order;
+          ++order;
+        }
+        node = rtems_chain_next (node);
+      }
+    }
+    node = rtems_chain_next (node);
+  }
+  rtems_rtl_set_error (errno, "section link not found");
+  return -1;
+}
+
+static void
+rtems_rtl_obj_sections_link_order (uint32_t mask, rtems_rtl_obj_t* obj)
+{
+  rtems_chain_control* sections = &obj->sections;
+  rtems_chain_node*    node = rtems_chain_first (sections);
+  int                  order = 0;
+  while (!rtems_chain_is_tail (sections, node))
+  {
+    rtems_rtl_obj_sect_t* sect = (rtems_rtl_obj_sect_t*) node;
+    if ((sect->flags & mask) == mask)
+    {
+      /*
+       * If the section is linked in order find the linked-to section's order
+       * and move the section in the section list to
+       */
+      if (sect->link == 0)
+        sect->load_order = order++;
+      else
+      {
+        sect->load_order =
+          rtems_rtl_obj_sections_linked_to_order (obj,
+                                                  sect->link,
+                                                  mask);
+      }
+    }
+    node = rtems_chain_next (node);
+  }
 }
 
@@ -647,4 +761,6 @@
   size_t               base_offset = 0;
   bool                 first = true;
+  int                  order = 0;
+
   while (!rtems_chain_is_tail (sections, node))
   {
@@ -653,34 +769,44 @@
     if ((sect->size != 0) && ((sect->flags & mask) != 0))
     {
-      if (!first)
-        base_offset = rtems_rtl_sect_align (base_offset, sect->alignment);
-
-      sect->base = base + base_offset;
-
-      if (rtems_rtl_trace (RTEMS_RTL_TRACE_LOAD_SECT))
-        printf ("rtl: loading: %s -> %8p (%zi)\n",
-                sect->name, sect->base, sect->size);
-
-      if ((sect->flags & RTEMS_RTL_OBJ_SECT_LOAD) == RTEMS_RTL_OBJ_SECT_LOAD)
+      if (sect->load_order == order)
       {
-        if (!handler (obj, fd, sect, data))
+        if (!first)
+          base_offset = rtems_rtl_sect_align (base_offset, sect->alignment);
+
+        first = false;
+
+        sect->base = base + base_offset;
+
+        if (rtems_rtl_trace (RTEMS_RTL_TRACE_LOAD_SECT))
+          printf ("rtl: loading:%2d: %s -> %8p (s:%zi f:%04lx a:%lu l:%02d)\n",
+                  order, sect->name, sect->base, sect->size,
+                  sect->flags, sect->alignment, sect->link);
+
+        if ((sect->flags & RTEMS_RTL_OBJ_SECT_LOAD) == RTEMS_RTL_OBJ_SECT_LOAD)
+        {
+          if (!handler (obj, fd, sect, data))
+          {
+            sect->base = 0;
+            return false;
+          }
+        }
+        else if ((sect->flags & RTEMS_RTL_OBJ_SECT_ZERO) == RTEMS_RTL_OBJ_SECT_ZERO)
+        {
+          memset (base + base_offset, 0, sect->size);
+        }
+        else
         {
           sect->base = 0;
+          rtems_rtl_set_error (errno, "section has no load/clear op");
           return false;
         }
+
+        base_offset += sect->size;
+
+        ++order;
+
+        node = rtems_chain_first (sections);
+        continue;
       }
-      else if ((sect->flags & RTEMS_RTL_OBJ_SECT_ZERO) == RTEMS_RTL_OBJ_SECT_ZERO)
-      {
-        memset (base + base_offset, 0, sect->size);
-      }
-      else
-      {
-        sect->base = 0;
-        rtems_rtl_set_error (errno, "section has no load op");
-        return false;
-      }
-
-      base_offset += sect->size;
-      first = false;
     }
 
@@ -699,11 +825,20 @@
   size_t text_size;
   size_t const_size;
+  size_t eh_size;
   size_t data_size;
   size_t bss_size;
 
   text_size  = rtems_rtl_obj_text_size (obj) + rtems_rtl_obj_const_alignment (obj);
-  const_size = rtems_rtl_obj_const_size (obj) + rtems_rtl_obj_data_alignment (obj);
+  const_size = rtems_rtl_obj_const_size (obj) + rtems_rtl_obj_eh_alignment (obj);
+  eh_size    = rtems_rtl_obj_eh_size (obj) + rtems_rtl_obj_data_alignment (obj);
   data_size  = rtems_rtl_obj_data_size (obj) + rtems_rtl_obj_bss_alignment (obj);
   bss_size   = rtems_rtl_obj_bss_size (obj);
+
+  /*
+   * Set the sizes held in the object data. We need this for a fast reference.
+   */
+  obj->text_size = text_size;
+  obj->eh_size   = eh_size;
+  obj->bss_size  = bss_size;
 
   /*
@@ -713,4 +848,5 @@
   if (!rtems_rtl_alloc_module_new (&obj->text_base, text_size,
                                    &obj->const_base, const_size,
+                                   &obj->eh_base, eh_size,
                                    &obj->data_base, data_size,
                                    &obj->bss_base, bss_size))
@@ -721,5 +857,5 @@
   }
 
-  obj->exec_size = text_size + const_size + data_size + bss_size;
+  obj->exec_size = text_size + const_size + eh_size + data_size + bss_size;
 
   if (rtems_rtl_trace (RTEMS_RTL_TRACE_LOAD_SECT))
@@ -729,4 +865,6 @@
     printf ("rtl: load sect: const - b:%p s:%zi a:%" PRIu32 "\n",
             obj->const_base, const_size, rtems_rtl_obj_const_alignment (obj));
+    printf ("rtl: load sect: eh    - b:%p s:%zi a:%" PRIu32 "\n",
+            obj->eh_base, eh_size, rtems_rtl_obj_eh_alignment (obj));
     printf ("rtl: load sect: data  - b:%p s:%zi a:%" PRIu32 "\n",
             obj->data_base, data_size, rtems_rtl_obj_data_alignment (obj));
@@ -734,4 +872,12 @@
             obj->bss_base, bss_size, rtems_rtl_obj_bss_alignment (obj));
   }
+
+  /*
+   * Determine the load order.
+   */
+  rtems_rtl_obj_sections_link_order (RTEMS_RTL_OBJ_SECT_TEXT,  obj);
+  rtems_rtl_obj_sections_link_order (RTEMS_RTL_OBJ_SECT_CONST, obj);
+  rtems_rtl_obj_sections_link_order (RTEMS_RTL_OBJ_SECT_EH,    obj);
+  rtems_rtl_obj_sections_link_order (RTEMS_RTL_OBJ_SECT_DATA,  obj);
 
   /*
@@ -743,4 +889,6 @@
       !rtems_rtl_obj_sections_loader (RTEMS_RTL_OBJ_SECT_CONST,
                                       obj, fd, obj->const_base, handler, data) ||
+      !rtems_rtl_obj_sections_loader (RTEMS_RTL_OBJ_SECT_EH,
+                                      obj, fd, obj->eh_base, handler, data) ||
       !rtems_rtl_obj_sections_loader (RTEMS_RTL_OBJ_SECT_DATA,
                                       obj, fd, obj->data_base, handler, data) ||
@@ -748,5 +896,5 @@
                                       obj, fd, obj->bss_base, handler, data))
   {
-    rtems_rtl_alloc_module_del (&obj->text_base, &obj->const_base,
+    rtems_rtl_alloc_module_del (&obj->text_base, &obj->const_base, &obj->eh_base,
                                 &obj->data_base, &obj->bss_base);
     obj->exec_size = 0;
@@ -973,5 +1121,5 @@
              */
 #define RTEMS_RTL_MAX_FILE_SIZE (256)
-            char  name[RTEMS_RTL_MAX_FILE_SIZE];
+            char name[RTEMS_RTL_MAX_FILE_SIZE];
 
             if (!rtems_rtl_seek_read (fd, extended_file_names + extended_off,
@@ -1017,5 +1165,5 @@
 }
 
-bool
+static bool
 rtems_rtl_obj_file_load (rtems_rtl_obj_t* obj, int fd)
 {
@@ -1025,8 +1173,19 @@
   {
     if (loaders[l].check (obj, fd))
+    {
+      obj->format = l;
       return loaders[l].load (obj, fd);
+    }
   }
 
   rtems_rtl_set_error (ENOENT, "no format loader found");
+  return false;
+}
+
+static bool
+rtems_rtl_obj_file_unload (rtems_rtl_obj_t* obj)
+{
+  if (obj->format >= 0 && obj->format < RTEMS_RTL_LOADERS)
+      return loaders[obj->format].unload (obj);
   return false;
 }
@@ -1058,5 +1217,4 @@
     if (!rtems_rtl_obj_archive_find (obj, fd))
     {
-      rtems_rtl_obj_caches_flush ();
       close (fd);
       return false;
@@ -1065,11 +1223,8 @@
 
   /*
-   * Call the format specific loader. Currently this is a call to the ELF
-   * loader. This call could be changed to allow probes then calls if more than
-   * one format is supported.
+   * Call the format specific loader.
    */
   if (!rtems_rtl_obj_file_load (obj, fd))
   {
-    rtems_rtl_obj_caches_flush ();
     close (fd);
     return false;
@@ -1081,6 +1236,4 @@
     return false;
   }
-
-  rtems_rtl_obj_caches_flush ();
 
   close (fd);
@@ -1093,5 +1246,5 @@
 {
   _rtld_linkmap_delete(obj);
-  rtems_rtl_symbol_obj_erase (obj);
-  return rtems_rtl_obj_free (obj);
-}
+  rtems_rtl_obj_file_unload (obj);
+  return true;
+}
